#version 450
#extension GL_ARB_separate_shader_objects : enable

// inputs
struct shader_input_0
{
	float2 texcoord : TEXCOORD0;
};

// outputs
struct shader_output_0
{
	float4 colour : COLOUR0;
};

// uniforms
layout(binding = 0) uniform ViewUniforms
{
	vec4 dims;
} view;

layout(binding = 1) uniform BlurDirection
{
	vec4 dir;
} dir;

layout(binding = 0) uniform sampler2D src;

void main()
{
	float numSamples = dir.dir.z;
	vec2 uvstep = dir.dir.xy * view.dims.zw;
	vec2 uv = shader_input_0.texcoord - (numSamples * 0.5 * uvstep);
	vec4 c = vec4(0.0, 0.0, 0.0, 0.0);
	for(int i = 0; i < numSamples; ++i)
	{
		c += texture(src, uv);
		uv += uvstep;
	}
	c /= numSamples;
	shader_output_0.colour = c;
}