#version 450
#extension GL_ARB_separate_shader_objects : enable

// inputs
struct shader_input_0
{
	float3 world_pos : POSITION1;
	float2 texcoord : TEXCOORD0;
	float3 normal : NORMAL0;
};

// outputs
struct shader_output_0
{
	float4 colour : COLOUR0;
};

layout(binding = 3) uniform EntityData
{
	mat4 world;
	vec4 user0;
	vec4 user1;
} entity;

void main()
{
	if(dot(shader_input_0.normal, vec3(0.0, 1.0, 0.0)) >= 0.99)
	{
		discard;
	}
	
	float t0 = shader_input_0.texcoord.x + entity.user1.x * 0.005;
	t0 = 1.0 - smoothstep(0.01, 0.02 + (sin(t0 * 64.0) * 0.5 + 0.5) * 0.02, shader_input_0.texcoord.y);
	float t1 = shader_input_0.texcoord.x + entity.user1.x * 0.01;
	t1 = 1.0 - smoothstep(0.01, 0.02 + (sin(t1 * 128.0) * 0.5 + 0.5) * 0.02, shader_input_0.texcoord.y);
	float t = max(t0, t1);
	
	vec4 colour = mix(entity.user0, vec4(0.0, 0.0, 0.0, 0.0), t);
	shader_output_0.colour = colour;
}