"variations":
{
	"forward":
	{
		"default": true
	},
	"gbuffer":
	{
		"blend_state":
		{
			"enabled": false
		}
	},
	"shadow_map":
	{
	}
}

#version 450
#extension GL_ARB_separate_shader_objects : enable

// inputs
forward/gbuffer:
{
	struct shader_input_0
	{
		float3 world_pos : POSITION1;
		float3 texcoord : TEXCOORD0;
		float3 normal : NORMAL0;
	};
}

// outputs
forward:
{
	struct shader_output_0
	{
		float4 colour : COLOUR0;
	};
}

gbuffer:
{
	struct shader_output_0
	{
		float4 normal : COLOUR0;
		float4 diffuse : COLOUR1;
		float4 specular : COLOUR2;
	};
}

layout(binding = 3) uniform EntityData
{
	mat4 world;
	vec4 user;
} entity;

forward/gbuffer:
{
	layout(binding = 0) uniform sampler2D surface_0;
	layout(binding = 1) uniform sampler2D edge_0;
	layout(binding = 2) uniform sampler2D surface_1;
	layout(binding = 3) uniform sampler2D edge_1;
}

void main()
{
	forward/gbuffer:
	{
		vec4 surface_colour_0 = texture(surface_0, shader_input_0.texcoord.xy);
		vec4 surface_colour_1 = texture(surface_1, shader_input_0.texcoord.xy);
		vec4 colour = mix(surface_colour_0, surface_colour_1, shader_input_0.texcoord.z);
		if(dot(shader_input_0.normal, vec3(0.0, 1.0, 0.0)) < 0.999)
		{
			float t = 1.0 - smoothstep(0.01, 0.02, shader_input_0.texcoord.y);
			vec4 edge_colour_0 = texture(edge_0, shader_input_0.texcoord.xy);
			vec4 edge_colour_1 = texture(edge_1, shader_input_0.texcoord.xy);
			vec4 edge_colour = mix(edge_colour_0, edge_colour_1, shader_input_0.texcoord.z);
			colour = mix(edge_colour, colour, t);
		}
	}
	
	forward:
	{
		shader_output_0.colour = colour;
	}
	
	gbuffer:
	{
		shader_output_0.diffuse = colour;
		shader_output_0.normal = vec4(shader_input_0.normal, 1.0);
		shader_output_0.specular =  vec4(0.0);
	}
}
