#pragma once

#include "codegen/combat_world.h"
#include "world.h"

using namespace engine;

namespace mancers
{
	struct CombatBehaviours
	{
		ID		m_behaviour[4];
		float	m_weight[4];
	};

	class CombatWorld : public World
	{
	public:
		COMPONENT_ARRAY(glm::vec3,			gridPos);
		COMPONENT_ARRAY(glm::vec3, 			gridScale);
		COMPONENT_ARRAY(maths::AABB,		gridAABB);
		COMPONENT_ARRAY(u32,				alignment);
		COMPONENT_ARRAY(u32,				health);
		COMPONENT_ARRAY(u32,				maxHealth);
		COMPONENT_ARRAY(CombatBehaviours,	behaviours);

		CombatWorld()
		{
			m_last = &m_behaviours;
		}

		void destroyEntity(size_t e) override
		{
			World::destroyEntity(e);
		}

		u64 enumNameToComponentFlagValue(const std::string& name) override
		{
			return e_combatCmp::nameToValue(name) | World::enumNameToEntityFlagValue(name);
		}

		u64 enumNameToEntityFlagValue(const std::string& name) override
		{
			return e_combatFlags::nameToValue(name) | World::enumNameToEntityFlagValue(name);
		}

		
	};
}