#include "engine_app.h"

#include "save.h"
#include "scenes/combat_scene.h"

class MancersApp : public engine::EngineApp
{
public:
	void setup() override
	{
		auto t = time(0);
		srand(t);

		utils::setCursorVisible(false);

		engine::EngineApp::setup();
		
		engine::SaveManager* sm = engine::SaveManager::get();
		sm->setup();
		sm->load(m_engine->getGameState()["saved"]);

		// register project specific functions
		m_engine->registerSceneCreateFunc(mancers::createCombatScene, "combat");

		engine::SceneDesc desc = {};
		desc.m_funcID = hash<std::string>("generic");
		desc.m_filename = "data/scenes/main_menu.scene";
		m_engine->loadScene(desc);
	}
};

App* createApp(const AppDesc& desc)
{
	MancersApp* app = memNew<MancersApp>();
	*(AppDesc*)app = desc;
	return app;
}